/*megaide_debug.h*/
/*
 * Linux MegaRAID IDEal Software RAID Stack
 * Copyright (c) 2001 LSI Logic Corporation, All Rights Reserved.
 *-----------------------------------------------------------------------------
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef __MEGAIDE_DEBUG_H__
#define __MEGAIDE_DEBUG_H__

/*Debug Levels*/
#define AR_DEBUG_EVERYTHING ((ulong)0xFFFFFFFF)
#define AR_DEBUG_MODULE     ((ulong)0x10000000)

#define AR_DBG_ENTRY        ((ulong)0x00000001)
#define AR_DBG_INIT         ((ulong)0x00000002)
#define AR_DEBUG_FINDDEV    ((ulong)0x00000004)
#define AR_DBG_ROM          ((ulong)0x00000008)

#define AR_DEBUG_WARNING    ((ulong)0x00000010)
#define AR_DEBUG_ERRORS     ((ulong)0x00000020)
#define AR_DEVEL_DEBUG      ((ulong)0x000000F0)

#define AR_DEBUG_SCSI_CMD   ((ulong)0x00000100)
#define AR_DEBUG_SCSI_CMD1  ((ulong)0x00000200)
#define AR_DEBUG_SCSI_CMD2  ((ulong)0x00000400)
#define AR_DEBUG_INTERUPT   ((ulong)0x00000800)

#define AR_DEBUG_RELEASE    ((ulong)0x00001000)
#define AR_DEBUG_IOCTL      ((ulong)0x00002000)
#define AR_DEBUG_ATA        ((ulong)0x00004000)
#define AR_DEBUG_SGLIST     ((ulong)0x00008000)

#define AR_DEBUG_CONFIG     ((ulong)0x00010000)
#define AR_UPDATE_IRCD      ((ulong)0x00020000)
#define AR_BP               ((ulong)0x00040000)
#define AR_DEBUG_PASSTHRU   ((ulong)0x00080000)

#define AR_HOT_PLUG         ((ulong)0x00100000)
#define AR_DBG_RECOVERY     ((ulong)0x00200000)
#define AR_DEBUG_DYN_DMA    ((ulong)0x00400000)
#define AR_DBG_NIT          ((ulong)0x00800000)

#define INTERNAL_REBUILD

//#define DEBUG_ON 0

//#define DBG_TIME_INTERVAL  0x04
//#define PERFORMANCE_NUMBER 0xFF

#ifdef DEBUG_ON
 #define BREAKPOINT         {asm("int $3");}
 #define AR_DEBUG(level, msg_string){\
  if(debug_level & level){\
   printk_Rlsi msg_string;\
  }\
 }
#else
 #define BREAKPOINT
 #define AR_DEBUG(level,msg_string) /* DO NOTHING */
#endif /*AR_DEBUG*/

#endif /*__MEGAIDE_DEBUG_H__*/
/*vi set ts=8:*/
