/*megaide_kernel_lib.h*/
/*
 * Linux MegaRAID IDEal Software RAID Stack
 * Copyright (c) 2001 LSI Logic Corporation, All Rights Reserved.
 *-----------------------------------------------------------------------------
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef __MEGAIDE_KERNEL_LIB_H__
#define __MEGAIDE_KERNEL_LIB_H__

extern void ScsiPortStallExecution(ULONG usecs);
extern UCHAR ScsiPortReadPortUchar(USHORT port);
extern USHORT ScsiPortReadPortUshort(USHORT port);
extern void ScsiPortReadPortBufferUshort(USHORT port, void *addr,
                                         ULONG count);
extern void ScsiPortWritePortUchar(USHORT port, UCHAR value);
extern void ScsiPortWritePortBufferUshort(USHORT port,
                                          const void * addr, ULONG count);
extern void ScsiPortWritePortUlong(USHORT port, UINT value);

extern ULONG ScsiPortReadRegisterUlong(ULONG addr);
extern void ScsiPortWriteRegisterUlong(ULONG addr, UINT value);
extern ULONG ScsiPortReadRegisterUchar(ULONG addr);
extern void ScsiPortWriteRegisterUchar(ULONG addr, UINT value);


extern __attribute__((regparm(0)))
        int printk_Rlsi(const char * fmt, ...)
       __attribute__ ((format (printf, 1, 2)));

extern int memcmp_Rlsi(const void * cs,const void * ct,size_t count);
extern void * memcpy_Rlsi(void * dest,const void *src,size_t count);
extern void * memmove_Rlsi(void * dest,const void *src,size_t count);
extern void * memset_Rlsi(void * s,int c,size_t count);
extern char * strncpy_Rlsi(char * dest,const char *src,size_t count);
extern int strncmp_Rlsi(const char * cs,const char * ct,size_t count);

extern int pci_read_config_word_Rlsi(HW_DEVICE_EXTENSION *pdev, 
                                     int where, USHORT *val);
extern int pci_read_config_byte_Rlsi(HW_DEVICE_EXTENSION *pdev, 
                                     int where, UCHAR *val);
extern int pci_write_config_word_Rlsi(HW_DEVICE_EXTENSION *pdev, 
                                     int where, USHORT val);
extern int pci_write_config_byte_Rlsi(HW_DEVICE_EXTENSION *pdev, 
                                     int where, UCHAR val);

extern void spin_lock_Rlsi(HW_DEVICE_EXTENSION *pdev);
extern void spin_unlock_Rlsi(HW_DEVICE_EXTENSION *pdev);

extern void wake_up_Rlsi(HW_DEVICE_EXTENSION *pdev);
extern void sleep_on_timeout_Rlsi(HW_DEVICE_EXTENSION *pdev);

extern USHORT pci_map_sg_Rlsi(HW_DEVICE_EXTENSION *pdev, 
                              FAST_IDE_SCB_EXTENSION *scb);
extern void pci_unmap_sg_Rlsi(HW_DEVICE_EXTENSION *pdev, 
                              FAST_IDE_SCB_EXTENSION *scb);
extern ULONG pci_map_single_Rlsi(HW_DEVICE_EXTENSION *pdev, 
                                 void * DataBuffer , ULONG len);
extern void pci_unmap_single_Rlsi(HW_DEVICE_EXTENSION *pdev, 
                                  void * DataBuffer , ULONG len);

extern void request_region_Rlsi(USHORT port, ULONG count);
extern void release_region_Rlsi(USHORT port, ULONG count);
extern u_long CURRENT_TIME_RLSI(void);
u_long get_jiffies_count(void);
u_long mega_get_hz_value(void);

#endif /* __MEGAIDE_KERNEL_LIB_H__ */
/*vi set ts=8:*/
