/*megaide_pci.h*/
/*
 * Linux MegaRAID IDEal Software RAID Stack
 * Copyright (c) 2001 LSI Logic Corporation, All Rights Reserved.
 *-----------------------------------------------------------------------------
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef __MEGAIDE_PCI_H__
#define __MEGAIDE_PCI_H__

#ifdef BP_SUPPORT
 ULONG bp_values[14] =
       { IOCTL_BPD_INIT_BACKPLANE,
         IOCTL_BPD_READ_REGISTER,
         IOCTL_BPD_WRITE_REGISTER,
         IOCTL_BPD_LED_CONTROL,
         IOCTL_BPD_BEEP_CONTROL,
         IOCTL_BPD_DOCK_STATUS,
         IOCTL_BPD_IDE_BUS_ISOLATION,
         IOCTL_BPD_GET_EVENT_LOG_INFO,
         IOCTL_BPD_CLEAR_EVENTS,
         IOCTL_BPD_ADD_EVENT,
         IOCTL_BPD_GET_EVENT,
         IOCTL_BPD_INITIALIZE,
         IOCTL_BPD_GET_ERROR_CODE,
         IOCTL_BPD_BEEP_STATUS
       };
#endif

/*MegaIDE driver Host Template*/
#define MEGAIDE \
{\
      name:         "MegaIDE",            /* Driver Name        */\
      proc_info:    megaide_proc_info,    /* proc driver info     */\
      detect:       megaide_detect,       /* Detect Host Adapter    */\
      release:      megaide_release,      /* Release Host Adapter    */\
      info:         megaide_info,         /* Driver Info Function    */\
      command:      megaide_command,      /* Command Function    */\
      queuecommand: megaide_queue,        /* Queue Command Function*/\
      bios_param:   megaide_biosparam,    /* Disk BIOS Parameters    */\
      eh_abort_handler:       eh_megaide_abort,        \
      eh_device_reset_handler:eh_megaide_reset_dev,        \
      eh_bus_reset_handler:   eh_megaide_reset_bus,        \
      eh_host_reset_handler:  eh_megaide_reset_host,        \
      can_queue:      M_IDE_MAX_CMD_PER_LUN,  /* Maximum Can Queue    */\
      this_id:        M_IDE_HOST_INITIATOR_ID,/* HBA Target ID    */\
      sg_tablesize:   M_IDE_MAX_SGLIST,       /* Scatter/Gather Table Size*/\
      cmd_per_lun:    M_IDE_MAX_CMD_PER_LUN,  /* SCSI Commands per LUN*/\
      present:        0,                      /* Number of boards    */\
      unchecked_isa_dma:0,                    /* Default Unchecked ISA DMA*/\
      use_clustering:   ENABLE_CLUSTERING,    /* Enable Clustering    */\
      use_new_eh_code:       1\
}

typedef struct _KERN_PHYSICAL_DRIVE_INFO_
{
    dma_addr_t  h_err_log_sec;
}
__attribute__ ((packed))
KERN_PHYSICAL_DRIVE_INFO;

typedef struct _KERN_CHANNEL_
{
    dma_addr_t  h_sgl_entry;
    dma_addr_t  h_disc_conf;
    dma_addr_t  h_enquiry_conf;
}
__attribute__ ((packed))
KERN_CHANNEL;

typedef struct _CARD_INFO
{
    HW_DEVICE_EXTENSION  DeviceExtension;
    KERN_PHYSICAL_DRIVE_INFO  PhysicalDrive[MAX_DRIVES_PER_CONTROLLER];
    KERN_CHANNEL  Channel[MAX_CHANNELS_PER_CONTROLLER];
    struct pci_dev  *pstDev;
    struct Scsi_Host  *pstScsiHost;
    wait_queue_head_t  wait_queue;
    struct completion  ICH5R_completion;
    spinlock_t  qSpinLock;

    ULONG  gate_keeper_buff_length;
    dma_addr_t  h_gate_keeper_buff;
    wait_queue_head_t  internal_wait;
    struct list_head  scb_ext_free_list;
    /*for IOCTL memory allocation*/
    struct semaphore  nit_lock;
    Scsi_Cmnd  *nit_scsi_cmd;
    char  *host_scribble;
    void  *ioctl_data;
    dma_addr_t  h_nit_scsi_cmd;
    dma_addr_t  h_host_scribble;
    dma_addr_t  h_ioctl_data;

#ifdef CONFIG_PROC_FS
    struct proc_dir_entry  *pstControllerProcDirEntry;
#endif/*CONFIG_PROC_FS*/

}
__attribute__ ((packed))
adapter_t;

typedef BOOLEAN (*FOUND_INTERRUPT_HANDLER)(HW_DEVICE_EXTENSION *pdev,
                                           UCHAR *pulChannel);
typedef BOOLEAN (*DISABLE_INTERRUPTS)(HW_DEVICE_EXTENSION *pdev);
typedef BOOLEAN (*ENABLE_INTERRUPTS)(HW_DEVICE_EXTENSION *pdev);
typedef BOOLEAN (*IS80PINCABLE)(HW_DEVICE_EXTENSION *pdev,
                                UCHAR ucChannelInd);
typedef BOOLEAN (*PROGRAMCONTROLLER)(HW_DEVICE_EXTENSION *pdev,
                                     UCHAR tid, UCHAR ucMode);
typedef BOOLEAN (*ISPOSTCOMMANDTODRIVESUCCESS)
                             (HW_DEVICE_EXTENSION *pdev,
                              ULONG ulTargetId,
                              ULONG ulStartBlock, ULONG ulBlockCount,
                              UCHAR ucCmd, ULONG ulSglPhysicalAddress);

typedef struct _CARD_SPECIFIC_FUNCTION
{
    FOUND_INTERRUPT_HANDLER  pfnFoundInterrupt;
    DISABLE_INTERRUPTS  pfnDisableInterrupts;
    ENABLE_INTERRUPTS  pfnEnableInterrupts;
    IS80PINCABLE pfnIs80PinCable;
    PROGRAMCONTROLLER  pfnProgramChip;
    ISPOSTCOMMANDTODRIVESUCCESS  pfnIsPostCmd;
}CARD_SPECIFIC_FUNCTION;


int mide_find_card(Scsi_Host_Template * pstHostTmp,unsigned short sPciVendor,
                   unsigned short sPciDev, long lFlag);
BOOLEAN mide_check_for_supported_device(struct pci_dev *pstDev,
                                        unsigned short sPciDev, unsigned short sSubsysId, 
                                        unsigned short sSubsysVId, long lFlag);
BOOLEAN mide_allocate_device_ext_mem (HW_DEVICE_EXTENSION *pdev,
                                      struct pci_dev *pstDev, 
                                      unsigned short sNumFound);
void mide_init_cardtype_and_speed (HW_DEVICE_EXTENSION *pdev, unsigned short deviceID);
BOOLEAN mide_init_base_address (HW_DEVICE_EXTENSION *pdev, 
                                struct pci_dev *pstDev);
void initialize_device_extension(HW_DEVICE_EXTENSION *pdev);
int mide_get_option_rom_info(HW_DEVICE_EXTENSION *pdev);
int mide_scan_option_rom(UCHAR *pcRom, ULONG ulRomSize,
                         HW_DEVICE_EXTENSION *pdev);
LONG HyperDiskScanForDevices(HW_DEVICE_EXTENSION *pdev);
BOOLEAN InitIdeRaidController(HW_DEVICE_EXTENSION *pdev);
BOOLEAN FindDevices(HW_DEVICE_EXTENSION *pdev, UCHAR Channel);
BOOLEAN GetIoMode(HW_DEVICE_EXTENSION *pdev, UCHAR TargetId);
BOOLEAN GetTransferMode(HW_DEVICE_EXTENSION *pdev, UCHAR TargetId);
BOOLEAN SetTransferMode(HW_DEVICE_EXTENSION *pdev, UCHAR TargetId,
                        MP_TRANSFER_MODE TransferMode);
BOOLEAN AssignSglPtrsForChannels(HW_DEVICE_EXTENSION *pdev);
void RemoveBuildInIDESupport(unsigned short ReqVenID, unsigned short ReqDevId,
                        unsigned short ReqSubsysId, unsigned short ReqSubsysVId);
BOOLEAN ClaimOurIOPorts(HW_DEVICE_EXTENSION *pdev);
BOOLEAN ReleaseOurIOPorts(HW_DEVICE_EXTENSION *pdev);
BOOLEAN IsDrivePresent(HW_DEVICE_EXTENSION *pdev, UCHAR tid);
BOOLEAN IssueIdentify(HW_DEVICE_EXTENSION *pdev, UCHAR DeviceNumber,
                      UCHAR Channel, UCHAR Command);
BOOLEAN InitDriveFeatures(HW_DEVICE_EXTENSION *pdev);
BOOLEAN InitSingleDriveFeatures(HW_DEVICE_EXTENSION *pdev, UCHAR ucDrvInd);
BOOLEAN set_multi_block_xfers(HW_DEVICE_EXTENSION *pdev, UCHAR tid);
void SetDriveParameters(HW_DEVICE_EXTENSION *pdev);
void SetDriveParams(HW_DEVICE_EXTENSION *pdev,  UCHAR DeviceNumber);
VOID CleanUpAdapter(HW_DEVICE_EXTENSION *pdev);
BOOLEAN PostCommandToDrive(HW_DEVICE_EXTENSION *pdev, ULONG ulTargetId,
                           ULONG ulStartBlock, ULONG ulBlockCount,
                           UCHAR ucCmd, ULONG ulSglPhysicalAddress);
HW_DEVICE_EXTENSION *GetDeviceExtension(u_char ucIndex);
#ifdef BP_SUPPORT
ULONG megaide_get_bp_opcode(ULONG opcode);
#endif

//Generic Functions
BOOLEAN FoundInterrupt(HW_DEVICE_EXTENSION *pdev, UCHAR *pulChannel);
BOOLEAN EnableInterrupts(HW_DEVICE_EXTENSION *pdev);
BOOLEAN DisableInterrupts(HW_DEVICE_EXTENSION *pdev);
BOOLEAN Is80PinCable(HW_DEVICE_EXTENSION *pdev, UCHAR ucChannelId);
BOOLEAN IsPostCommandToDriveSuccess(HW_DEVICE_EXTENSION *pdev, ULONG ulTargetId,
                                    ULONG ulStartBlock, ULONG ulBlockCount,
                                    UCHAR ucCmd, ULONG ulSglPhysicalAddress);
//CMD648/649 Chipset Related Functions
BOOLEAN Found64xInterrupt(HW_DEVICE_EXTENSION *pdev, UCHAR *pulChannel);
BOOLEAN Enable64xInterrupts(HW_DEVICE_EXTENSION *pdev);
BOOLEAN Disable64xInterrupts(HW_DEVICE_EXTENSION *pdev);
BOOLEAN ProgramDriveFor64xChip(HW_DEVICE_EXTENSION *pdev,
                               UCHAR tid, UCHAR TransferMode);
BOOLEAN Is64x80PinCable(HW_DEVICE_EXTENSION *pdev, UCHAR ucChannelId);
BOOLEAN IsPostCommandToDriveSuccess64x(HW_DEVICE_EXTENSION *pdev, ULONG tid,
                                       ULONG ulStartBlock, ULONG ulBlockCount,
                                       UCHAR cmd, ULONG ulSglPhysicalAddress);

//CMD680 Chipset Related Functions
BOOLEAN Found68xInterrupt(HW_DEVICE_EXTENSION *pdev, UCHAR *pulChannel);
BOOLEAN ProgramDriveFor68xChip(HW_DEVICE_EXTENSION *pdev,
                               UCHAR tid, UCHAR ucMode);
BOOLEAN Enable68xInterrupts(HW_DEVICE_EXTENSION *pdev);
BOOLEAN Disable68xInterrupts(HW_DEVICE_EXTENSION *pdev);
BOOLEAN Is68x80PinCable(HW_DEVICE_EXTENSION *pdev, UCHAR ucChannelId);
BOOLEAN IsPostCommandToDriveSuccess68x(HW_DEVICE_EXTENSION *pdev, ULONG tid,
                                       ULONG ulStartBlock, ULONG ulBlockCount,
                                       UCHAR cmd, ULONG ulSglPhysicalAddress);

//ServerWorks CSB5 Related Functions
BOOLEAN FoundCSB5Interrupt(HW_DEVICE_EXTENSION *pdev, UCHAR *pulChannel);
BOOLEAN ProgramDriveForCSB5Chip(HW_DEVICE_EXTENSION *pdev,
                                UCHAR tid, UCHAR ucMode);
BOOLEAN EnableCSB5Interrupts(HW_DEVICE_EXTENSION *pdev);
BOOLEAN DisableCSB5Interrupts(HW_DEVICE_EXTENSION *pdev);
BOOLEAN IsCSB580PinCable(HW_DEVICE_EXTENSION *pdev, UCHAR ucChannelId);
BOOLEAN IsPostCommandToDriveSuccessCSB5(HW_DEVICE_EXTENSION *pdev, ULONG tid,
                                      ULONG ulStartBlock, ULONG ulBlockCount,
                                      UCHAR ucCmd, ULONG ulSglPhysicalAddress);

//ServerWorks CSB6 Related Functions
BOOLEAN FoundCSB6Interrupt(HW_DEVICE_EXTENSION *pdev, UCHAR *pulChannel);
BOOLEAN ProgramDriveForCSB6Chip(HW_DEVICE_EXTENSION *pdev,
                                UCHAR tid, UCHAR ucMode);
BOOLEAN EnableCSB6Interrupts(HW_DEVICE_EXTENSION *pdev);
BOOLEAN DisableCSB6Interrupts(HW_DEVICE_EXTENSION *pdev);
BOOLEAN IsCSB680PinCable(HW_DEVICE_EXTENSION *pdev, UCHAR ucChannelId);

//ICH5R Support
BOOLEAN FoundICH5RInterrupt(HW_DEVICE_EXTENSION *pdev, UCHAR *pulChannel);
BOOLEAN ProgramDriveForICH5RChip(HW_DEVICE_EXTENSION *pdev,
			UCHAR tid, UCHAR ucMode);
BOOLEAN EnableICH5RInterrupts(HW_DEVICE_EXTENSION *pdev);
BOOLEAN DisableICH5RInterrupts(HW_DEVICE_EXTENSION *pdev);
BOOLEAN IsICH5R80PinCable(HW_DEVICE_EXTENSION *pdev, UCHAR ucChannelId);
BOOLEAN IsPostCommandToDriveSuccessICH5R(HW_DEVICE_EXTENSION *pdev, ULONG tid,
			ULONG ulStartBlock, ULONG ulBlockCount,
			UCHAR ucCmd, ULONG ulSglPhysicalAddress);
void ICH5R_reset_all_channels(HW_DEVICE_EXTENSION *pdev);
void mega_start_ICH5R_poll_thread(HW_DEVICE_EXTENSION *pdev);
void mega_kill_ICH5R_poll_thread(HW_DEVICE_EXTENSION *pdev);
void mega_ICH5R_poll_thread(HW_DEVICE_EXTENSION *pdev);

//athena chipset Related Functions
BOOLEAN EnableAthenaInterrupts(HW_DEVICE_EXTENSION *pdev);
BOOLEAN DisableAthenaInterrupts(HW_DEVICE_EXTENSION *pdev);
extern BOOLEAN mide_handle_athena_pm_hp(HW_DEVICE_EXTENSION *pdev);
extern BOOLEAN AthenaEnablePMInterrupts(HW_DEVICE_EXTENSION *pdev);
extern BOOLEAN AthenaEnableHPInterrupt(HW_DEVICE_EXTENSION *pdev);
extern BOOLEAN AthenaDisablePMInterrupts(HW_DEVICE_EXTENSION *pdev);
extern BOOLEAN AthenaDisableHPInterrupt(HW_DEVICE_EXTENSION *pdev);
extern BOOLEAN AthenaInitializePMRegisters(HW_DEVICE_EXTENSION *pdev);
extern BOOLEAN AthenaMoveInterfaceToActiveMode(HW_DEVICE_EXTENSION *pdev,
                                               UCHAR ucDriveId);
extern UCHAR AthenaDetectPhysicalChange(HW_DEVICE_EXTENSION *pdev,UCHAR chan);

/*externs in the megaide_lib.o*/
extern void FlushCache(HW_DEVICE_EXTENSION *pdev);
extern size_t get_gatekeeper_size(void);
extern size_t get_scb_extension_size(void);
extern size_t get_physcial_drive_command_size(void);
extern BOOLEAN IssuePowerOnResetToDrives(HW_DEVICE_EXTENSION *pdev);
extern BOOLEAN StopBusMasterTransfers(HW_DEVICE_EXTENSION *pdev);
extern void AtapiHwInitialize(HW_DEVICE_EXTENSION *pdev);
extern BOOLEAN GetConfigInfoAndErrorLogSectorInfo(HW_DEVICE_EXTENSION *pdev);
extern BOOLEAN ConfigureRaidDrives(HW_DEVICE_EXTENSION *pdev, UCHAR *pBuffer);
extern BOOLEAN EnquireProperties(HW_DEVICE_EXTENSION *pdev, BOOLEAN blBootTime);
extern void megaide_kill_backgroundtask_and_wait(HW_DEVICE_EXTENSION *pdev);
extern void ClearPCIInterupt(HW_DEVICE_EXTENSION *pdev, UCHAR ucChannel);
extern void check_for_config_update(HW_DEVICE_EXTENSION *pdev);
extern BOOLEAN megaide_atapi_startio(HW_DEVICE_EXTENSION *pdev,
                                      FAST_IDE_SCB_EXTENSION *scb);
extern UCHAR HandleIOCTLCall(HW_DEVICE_EXTENSION *pdev,
                             FAST_IDE_SCB_EXTENSION *scb);
extern void megaide_abort_ioctl(HW_DEVICE_EXTENSION *pdev,
                                FAST_IDE_SCB_EXTENSION *scb);
extern BOOLEAN FastIDEResetBus(HW_DEVICE_EXTENSION *pdev);
extern void FastIDEInterrupt(HW_DEVICE_EXTENSION *pdev);
extern LOGICAL_DRIVE_INFO *GetLDInfo(HW_DEVICE_EXTENSION *pdev,
                                     UCHAR  chan, UCHAR tid, UCHAR Lun);
extern BOOLEAN SetMaxTransferMode(HW_DEVICE_EXTENSION *pdev, UCHAR TargetId);
extern UCHAR GetInquiryTransferMode(HW_DEVICE_EXTENSION *pdev, UCHAR TargetId);


#ifdef BP_SUPPORT
ULONG megaide_get_bp_opcode(ULONG opcode);
#endif


#ifdef BP_SUPPORT
extern ULONG idebp_discovery(HW_DEVICE_EXTENSION *pdev);
extern void idebp_release(HW_DEVICE_EXTENSION *pdev);
extern ULONG idebp_check_dock_status(HW_DEVICE_EXTENSION *pdev);
#endif

#endif /*__MEGAIDE_INIT_H__*/
/*vi set ts=8:*/
