/*megaide_proc.h*/
/*
 * Linux MegaRAID IDEal Software RAID Stack
 * Copyright (c) 2001 LSI Logic Corporation, All Rights Reserved.
 *-----------------------------------------------------------------------------
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef __MEGAIDE_PROC_H__
#define __MEGAIDE_PROC_H__

int megaide_proc_info(char *pcBuffer, char **ppcStart,
                      off_t offset,int iLength, int iHostNo, int iInOut);
void megaideproc_attach(void);
void megaideproc_detach(HW_DEVICE_EXTENSION *pdev);
int mega_proc_printf(HW_DEVICE_EXTENSION *pdev, const char *pcFmt, ...);
int mega_proc_read_config(char *page, char **start,
                          off_t offset, int iCount, int *eof, void *data);
int string_to_integers(const char *str,ULONG *pulValues, int max_count);
void pdrv_status_to_string(MP_PHYSICAL_DRIVE_STATUS eStatus,char *cString);
int mega_proc_read_pdrv_info(char *page, char **start, off_t offset,
                             int iCount, int *eof, void *data);
int mega_proc_read_registers(char *page, char **start, off_t offset,
                             int iCount, int *eof, void *data);
int mega_proc_read_ldrv_info(char *page, char **start, off_t offset,
                             int iCount, int *eof, void *data);
void create_logical_drive_entries(struct proc_dir_entry *pstParent,
                                  HW_DEVICE_EXTENSION *pdev);
void create_physical_drive_entries(struct proc_dir_entry *pstParent,
                                   HW_DEVICE_EXTENSION *pdev);
void megaide_create_proc_entry(int iIndex, struct proc_dir_entry *pstParent);
int mega_proc_read_status(char *page, char **start, off_t offset,
                          int iCount, int *eof, void *data);

#endif /*__MEGAIDE_PROC_H__*/
/*vi set ts=8:*/
