/*megaide_scsi.h*/
/*
 * Linux MegaRAID IDEal Software RAID Stack
 * Copyright (c) 2001 LSI Logic Corporation, All Rights Reserved.
 *-----------------------------------------------------------------------------
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *-----------------------------------------------------------------------------
 */

#ifndef __MEGAIDE_SCSI_H__
#define __MEGAIDE_SCSI_H__

static int megaide_detect(Scsi_Host_Template * hostTpl);
static const char *megaide_info(struct Scsi_Host * host);
static int megaide_release(struct Scsi_Host * host);
static int megaide_queue(Scsi_Cmnd * scmd, void(*scsi_done)(Scsi_Cmnd *));
static ULONG FastIDEProcessAndQueueRequest(HW_DEVICE_EXTENSION *pdev,
                                           Scsi_Cmnd *scmd);
static void megaide_complete_command(HW_DEVICE_EXTENSION *pdev,
                                     FAST_IDE_SCB_EXTENSION *scb, int result);
static int megaide_command(Scsi_Cmnd * scmd);
static void mide_internal_done(Scsi_Cmnd * scmd);
static int megaide_abort(Scsi_Cmnd * scmd);
static int megaide_reset(Scsi_Cmnd * scmd, UINT i_ResetFlags);
static int megaide_biosparam(Disk * disk, kdev_t dev, int * piGeom);
static void megaide_isr(int iIrq, void *vpDevp, struct pt_regs * pstRegs);
static int eh_megaide_abort(Scsi_Cmnd *scmd);
static int eh_megaide_reset_bus(Scsi_Cmnd *scmd);
static int eh_megaide_reset_host(Scsi_Cmnd *scmd);
static int eh_megaide_reset_dev(Scsi_Cmnd *scmd);
static int megaide_reboot_notify (struct notifier_block *, ULONG, void *);
static int mide_scsi_free (HW_DEVICE_EXTENSION *pDE,
                           void *data, UINT length);
static void * mide_scsi_malloc (HW_DEVICE_EXTENSION *pDE, UINT length);
static int mide_init_cmd_memory_pool (HW_DEVICE_EXTENSION *pDE);
static int mide_free_cmd_memory_pool (HW_DEVICE_EXTENSION *pDE);
static FAST_IDE_SCB_EXTENSION *
        mide_get_scb_from_pool (HW_DEVICE_EXTENSION *pDE);
static int mide_release_scb_pool_memory (HW_DEVICE_EXTENSION *pDE,
                                         FAST_IDE_SCB_EXTENSION *scb);
void fill_sense_buffer(FAST_IDE_SCB_EXTENSION *scb , UCHAR error_byte,
            BOOLEAN blReadWriteError , ULONG error_sector);
ULONG GetPhysicalAddressAndLength(void * request_buffer,
                                          unsigned short sglem , 
                                          ULONG ulDataOffset, 
                                          ULONG *pulContiguousLength);

#endif /*__MEGAIDE_SCSI_H__*/
