/*megaide_kernel_lib.c*/
/*
 * Linux MegaRAID IDEal Software RAID Stack
 * Copyright (c) 2001 LSI Logic Corporation, All Rights Reserved.
 *-----------------------------------------------------------------------------
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *-----------------------------------------------------------------------------
 */

/*library calls*/
void
ScsiPortStallExecution(ULONG usecs)
{ udelay(usecs); return; }

void
ScsiPortReadPortBufferUshort(USHORT port, void *addr, ULONG count)
{
 insw (port,addr,count);
 return;
}

void
ScsiPortWritePortBufferUshort(USHORT port, const void *addr, ULONG count)
{
 outsw (port,addr,count);
 return;
}

/**************************************************************************/
/**************************************************************************/

UCHAR
ScsiPortReadPortUchar(USHORT port)
{
UCHAR return_val;
#ifdef DEBUG_IO_ACCESS
HW_DEVICE_EXTENSION *pdev;
adapter_t * adapter;
#endif

 return_val = inb(port);
#ifdef DEBUG_IO_ACCESS
	adapter = (adapter_t *)gastCardInfo[0];
	pdev = &adapter->DeviceExtension;
	if(pdev->debug_io_head >= (MAX_IO_ACCESS_LOG_ENTRIES-1))
		pdev->debug_io_head=0;
	else
		pdev->debug_io_head++;
	pdev->debug_io[pdev->debug_io_head].io_access=IO_ACCESS_READ_IO;
	pdev->debug_io[pdev->debug_io_head].io_register=(ULONG)port;
	pdev->debug_io[pdev->debug_io_head].io_value=(ULONG)return_val;
#endif
return(return_val);
}

USHORT
ScsiPortReadPortUshort(USHORT port)
{
USHORT return_val;
#ifdef DEBUG_IO_ACCESS
HW_DEVICE_EXTENSION *pdev;
adapter_t * adapter;
#endif

 return_val = inw(port);
#ifdef DEBUG_IO_ACCESS
	adapter = (adapter_t *)gastCardInfo[0];
	pdev = &adapter->DeviceExtension;
	if(pdev->debug_io_head >= (MAX_IO_ACCESS_LOG_ENTRIES-1))
		pdev->debug_io_head=0;
	else
		pdev->debug_io_head++;
	pdev->debug_io[pdev->debug_io_head].io_access=IO_ACCESS_READ_IO;
	pdev->debug_io[pdev->debug_io_head].io_register=(ULONG)port;
	pdev->debug_io[pdev->debug_io_head].io_value=(ULONG)return_val;
#endif
return(return_val);
}

ULONG
ScsiPortReadPortUlong(USHORT port)
{
ULONG return_val;
#ifdef DEBUG_IO_ACCESS
HW_DEVICE_EXTENSION *pdev;
adapter_t * adapter;
#endif

 return_val = inl(port);
#ifdef DEBUG_IO_ACCESS
	adapter = (adapter_t *)gastCardInfo[0];
	pdev = &adapter->DeviceExtension;
	if(pdev->debug_io_head >= (MAX_IO_ACCESS_LOG_ENTRIES-1))
		pdev->debug_io_head=0;
	else
		pdev->debug_io_head++;
	pdev->debug_io[pdev->debug_io_head].io_access=IO_ACCESS_READ_IO;
	pdev->debug_io[pdev->debug_io_head].io_register=(ULONG)port;
	pdev->debug_io[pdev->debug_io_head].io_value=(ULONG)return_val;
#endif
return(return_val);
}

void
ScsiPortWritePortUchar(USHORT port, UCHAR value)
{
#ifdef DEBUG_IO_ACCESS
adapter_t * adapter;
HW_DEVICE_EXTENSION *pdev;
	adapter = (adapter_t *)gastCardInfo[0];
	pdev = &adapter->DeviceExtension;
	if(pdev->debug_io_head >= (MAX_IO_ACCESS_LOG_ENTRIES-1))
		pdev->debug_io_head=0;
	else
		pdev->debug_io_head++;
	pdev->debug_io[pdev->debug_io_head].io_access=IO_ACCESS_WRITE_IO;
	pdev->debug_io[pdev->debug_io_head].io_register=(ULONG)port;
	pdev->debug_io[pdev->debug_io_head].io_value=(ULONG)value;
#endif
 outb(value,port);
 return;
}


void
ScsiPortWritePortUlong(USHORT port, UINT value)
{
#ifdef DEBUG_IO_ACCESS
adapter_t * adapter;
HW_DEVICE_EXTENSION *pdev;
	adapter = (adapter_t *)gastCardInfo[0];
	pdev = &adapter->DeviceExtension;
	if(pdev->debug_io_head >= (MAX_IO_ACCESS_LOG_ENTRIES-1))
		pdev->debug_io_head=0;
	else
		pdev->debug_io_head++;
	pdev->debug_io[pdev->debug_io_head].io_access=IO_ACCESS_WRITE_IO;
	pdev->debug_io[pdev->debug_io_head].io_register=(ULONG)port;
	pdev->debug_io[pdev->debug_io_head].io_value=(ULONG)value;
#endif
 outl(value,port);
 return;
}

/**************************************************************************/


ULONG
ScsiPortReadRegisterUlong(ULONG addr)
{
return readl (addr);
}

void
ScsiPortWriteRegisterUlong(ULONG addr, UINT value)
{
 writel(value, addr);
}

ULONG
ScsiPortReadRegisterUchar(ULONG addr)
{
return readb (addr);
}

void
ScsiPortWriteRegisterUchar(ULONG addr, UINT value)
{
 writeb(value, addr);
}

/**************************************************************************/

int
memcmp_Rlsi(const void *cs,const void *ct,size_t count)
{ return memcmp(cs, ct, count); }

void *
memcpy_Rlsi(void *dest,const void *src,size_t count)
{ return memcpy(dest,src,count); }

void *
memmove_Rlsi(void *dest,const void *src,size_t count)
{ return memmove(dest,src,count); }

void *
memset_Rlsi(void *s,int c,size_t count)
{ return memset(s,c,count); }

char *
strncpy_Rlsi(char * dest,const char *src,size_t count)
{ return strncpy(dest,src,count); }

int
strncmp_Rlsi(const char * cs,const char * ct,size_t count)
{ return strncmp(cs,ct,count); }

int
pci_read_config_word_Rlsi(HW_DEVICE_EXTENSION *pdev, int where, USHORT *val)
{
int return_val;
	adapter_t *adapter = (adapter_t *)pdev->adapter;
	return_val = pci_read_config_word(adapter->pstDev,where,val);
#ifdef DEBUG_IO_ACCESS
	if(pdev->debug_io_head >= (MAX_IO_ACCESS_LOG_ENTRIES-1))
		pdev->debug_io_head=0;
	else
		pdev->debug_io_head++;
	pdev->debug_io[pdev->debug_io_head].io_access=IO_ACCESS_READ_PCI;
	pdev->debug_io[pdev->debug_io_head].io_register=(ULONG)where;
	pdev->debug_io[pdev->debug_io_head].io_value=(ULONG)*val;
#endif

return(return_val);
}

int
pci_read_config_byte_Rlsi(HW_DEVICE_EXTENSION *pdev, int where, UCHAR *val)
{
int return_val;
	adapter_t *adapter = (adapter_t *)pdev->adapter;
	return_val = pci_read_config_byte(adapter->pstDev,where,val);
#ifdef DEBUG_IO_ACCESS
	if(pdev->debug_io_head == (MAX_IO_ACCESS_LOG_ENTRIES-1))
		pdev->debug_io_head=0;
	else
		pdev->debug_io_head++;
	pdev->debug_io[pdev->debug_io_head].io_access=IO_ACCESS_READ_PCI;
	pdev->debug_io[pdev->debug_io_head].io_register=(ULONG)where;
	pdev->debug_io[pdev->debug_io_head].io_value=(ULONG)*val;
#endif

return(return_val);
}

int
pci_write_config_word_Rlsi(HW_DEVICE_EXTENSION *pdev,
                           int where, USHORT val)
{
	adapter_t *adapter = (adapter_t *)pdev->adapter;

#ifdef DEBUG_IO_ACCESS
	if(pdev->debug_io_head == (MAX_IO_ACCESS_LOG_ENTRIES-1))
		pdev->debug_io_head=0;
	else
		pdev->debug_io_head++;
	pdev->debug_io[pdev->debug_io_head].io_access=IO_ACCESS_WRITE_PCI;
	pdev->debug_io[pdev->debug_io_head].io_register=(ULONG)where;
	pdev->debug_io[pdev->debug_io_head].io_value=(ULONG)val;
#endif
	return pci_write_config_word(adapter->pstDev,where,val);

}

int
pci_write_config_byte_Rlsi(HW_DEVICE_EXTENSION *pdev,
                           int where, UCHAR val)
{
	adapter_t *adapter = (adapter_t *)pdev->adapter;

#ifdef DEBUG_IO_ACCESS
	if(pdev->debug_io_head == (MAX_IO_ACCESS_LOG_ENTRIES-1))
		pdev->debug_io_head=0;
	else
		pdev->debug_io_head++;
	pdev->debug_io[pdev->debug_io_head].io_access=IO_ACCESS_WRITE_PCI;
	pdev->debug_io[pdev->debug_io_head].io_register=(ULONG)where;
	pdev->debug_io[pdev->debug_io_head].io_value=(ULONG)val;
#endif
	return pci_write_config_byte(adapter->pstDev,where,val);
}

void
spin_lock_Rlsi(HW_DEVICE_EXTENSION *pdev)
{
	adapter_t *adapter = (adapter_t *)pdev->adapter;
	spin_lock(&adapter->qSpinLock);
}

void
spin_unlock_Rlsi(HW_DEVICE_EXTENSION *pdev)
{
	adapter_t *adapter;
	adapter = (adapter_t *)pdev->adapter;
	spin_unlock(&adapter->qSpinLock);
}

void
wake_up_Rlsi(HW_DEVICE_EXTENSION *pdev)
{
	adapter_t *adapter = (adapter_t *)pdev->adapter;
	wake_up(&adapter->internal_wait);
}

void
sleep_on_timeout_Rlsi(HW_DEVICE_EXTENSION *pdev)
{
	adapter_t *adapter = (adapter_t *)pdev->adapter;
	sleep_on_timeout(&adapter->internal_wait, 5 * HZ);
}

asmlinkage int
printk_Rlsi(const char *fmt, ...)
{
	va_list ap;
	char buf[256];

	va_start(ap, fmt);
	vsprintf(buf, fmt, ap);
	va_end(ap);

	return printk(buf);
}

ULONG
pci_map_single_Rlsi(HW_DEVICE_EXTENSION *pdev, void *buff , ULONG len)
{
	ULONG ulPhysicalAddress;
	adapter_t *adapter = (adapter_t *)pdev->adapter;

	ulPhysicalAddress = (ULONG) pci_map_single(adapter->pstDev,
	                                           (void *) buff,
	                                           len,
	                                           PCI_DMA_BIDIRECTIONAL);
	return ulPhysicalAddress;
}

void
pci_unmap_single_Rlsi(HW_DEVICE_EXTENSION *pdev, void *buff , ULONG len)
{
	adapter_t *adapter = (adapter_t *)pdev->adapter;
	pci_unmap_single(adapter->pstDev,
	                 (dma_addr_t) buff,
	                 len,
	                 PCI_DMA_BIDIRECTIONAL);
}

USHORT
pci_map_sg_Rlsi(HW_DEVICE_EXTENSION *pdev, FAST_IDE_SCB_EXTENSION *scb)
{
	u_long count_sg;
	adapter_t *adapter = (adapter_t *)pdev->adapter;
	count_sg = pci_map_sg(adapter->pstDev,
	                     (struct scatterlist *) scb->request_buffer,
	                     scb->sglem,
	                     PCI_DMA_BIDIRECTIONAL);
	return count_sg;
}

void
pci_unmap_sg_Rlsi(HW_DEVICE_EXTENSION *pdev, FAST_IDE_SCB_EXTENSION *scb)
{
	adapter_t *adapter = (adapter_t *)pdev->adapter;
	if (scb->sglem) {
		pci_unmap_sg(adapter->pstDev,
		             (struct scatterlist *) scb->request_buffer,
		             scb->sglem, PCI_DMA_BIDIRECTIONAL);
	}
}

u_long
CURRENT_TIME_RLSI(void)
{ return CURRENT_TIME; }

u_long get_jiffies_count(void)
{ return jiffies; }

u_long mega_get_hz_value(void)
{ return HZ; }

void
request_region_Rlsi(USHORT port, ULONG count)
{ request_region(port, count, "megaide"); }

void
release_region_Rlsi(USHORT port, ULONG count)
{ release_region (port , count); }

/*vi set ts=8:*/

